> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Get B2B Storefront Token

POST https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront
Content-Type: application/json

Generates a storefront authToken based on the supplied `customerId` of a storefront customer or Company user. You can use [Get Users](/developer/api-reference/rest/b2b/management/users) to retrieve the IDs of Company users, or you can use [Get All Customers](/developer/api-reference/rest/admin/management/customers/v3) to retrieve IDs for B2C customers and B2B buyers alike.

You can also use the [BigCommerce Storefront GraphQL API](/developer/docs/storefront/guides/graphql-storefront-api/authentication#login-mutation) to generate a Customer Access Token (CAT) and include it in the request, but this is not required for a successful response.

The storefront authToken obtained from this endpoint is valid for **1 day**.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/b2b/management/authentication/post-auth-customers-storefront

## Authentication

- `X-Auth-Token` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts). | For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).
- `X-Store-Hash` header (required) — | Header | Argument | Description | |:-------|:---------|:------------| | `X-Store-Hash` | `store_hash` | The unique store hash associated with a BigCommerce store that has B2B Edition enabled. |

## Request

### Body (application/json)

This endpoint expects an object.

- `customerId` (integer, required) — The ID of a BigCommerce customer account with a corresponding Company user account.
- `channelId` (integer, optional, default: 1) — The storefront channel ID where the order was placed.
- `customerAccessToken` (customerAccessToken, optional) — This object contains information related to the Customer Access Token (CAT) being associated with the storefront authToken.

## Response

### 200

OK

- `code` (integer, optional, default: 200) — The HTTP Status code of the response.
- `data` (AuthCustomersStorefrontPostResponsesContentApplicationJsonSchemaData, optional)
- `meta` (AuthCustomersStorefrontPostResponsesContentApplicationJsonSchemaMeta, optional)

## Types

### customerAccessToken

This object contains information related to the Customer Access Token (CAT) being associated with the storefront authToken.

- `expires_at` (string, optional) — The expiration date of the CAT, in [ISO format](https://www.iso.org/iso-8601-date-and-time-format.html).
- `value` (string, optional)

### AuthCustomersStorefrontPostResponsesContentApplicationJsonSchemaData

- `token` (list of string, optional) — The token value used to authenticate requests.

### AuthCustomersStorefrontPostResponsesContentApplicationJsonSchemaMeta

- `message` (string, optional)

## Examples

**Request**

```json
{
  "customerId": 456
}
```

**Response**

```json
{
  "code": 200,
  "data": {
    "token": [
      "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJlbWFpbCI6IjEyM0AxMi5jb20iLCJiY19jdXN0b21lcl9pZCI6MzEzLCJzdG9yZV9oYXNoIjoiaW1rOHp6N2ppcCIsImRiIjoiZGVmYXVsdCIsImJjX2NoYW5uZWxfaWQiOjEsImV4cCI6MTY5MDg1NDI5Mn0.97rY-1aGDFKtLbIePR5g202AHZJ0x2kDjmyzGVGK45"
    ]
  },
  "meta": {
    "message": "SUCCESS"
  }
}
```

**SDK Code**

```python
import requests

url = "https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront"

payload = { "customerId": 456 }
headers = {
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront';
const options = {
  method: 'POST',
  headers: {'X-Auth-Token': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"customerId":456}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront"

	payload := strings.NewReader("{\n  \"customerId\": 456\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"customerId\": 456\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"customerId\": 456\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront', [
  'body' => '{
  "customerId": 456
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"customerId\": 456\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["customerId": 456] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api-b2b.bigcommerce.com/api/io/auth/customers/storefront")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```